

#load the clr module and use it to load the dll into memory
import clr
clr.AddReference ("Kratos_3") #note that the dll needs to be somewhere findable, such as the same folder as this file
#remember that the dll architecture (x64 or x86) must match the mode python is running in (64 bit or 32 bit)

#Now that we have loaded Kratos_3 into memory, we can start a FactSetOnDemand object
#We also need to load arrays from system in order to be able to create .NET string arrays
from System import Array
from Kratos_3 import *
from Kratos_3.Network import *
from Kratos_3.RunTimePlatform import *

def printOutFactletResults(df):
    if(df.hasError()):
        df.throwErrorIfAnyIsPresent()
    print(fsod.GetEventLogger().getOutputBuffer())
    for row in range(df.getNumberOfRows()):
        for col in range(df.getNumberOfColumns()):
            o = df.getCellAt(row, col)
            print("Row: " + str(row) + ", Col: " + str(col) + ", Value: " + str(o))

fsod = FactSetOnDemand()
config = fsod.getConfig()

# Set our configuration. We definitely need to set our username and password, as given to us by FactSet Support staff
config.setConfig(ConfigOptions.DataDirectUserName, "<ENTER USERNAME HERE>")
config.setConfig(ConfigOptions.DataDirectPassword, "<ENTER PASSWORD HERE>")

uFactlet = UploadFactlet("TestOFDB_Python", Array[str](["ID","Date","my_price","my_volume"]), Array[str](["Id","Date","Double","Double"]))
dates = ["04/10/2013","04/11/2013","04/12/2013"]
fds_price = [93.33, float('nan'), 92.65]
fds_volume = [388.205, float('nan'), 359.396]
xom_price = [88.68, float('nan'), 89.22]
xom_volume = [14826.0, float('nan'), 14980.0]

for i in range(len(dates)):
    uFactlet.addDataPoint('FDS')
    uFactlet.addDataPoint(dates[i])
    uFactlet.addDataPoint(fds_price[i])
    uFactlet.addDataPoint(fds_volume[i])

for i in range(len(dates)):
    uFactlet.addDataPoint('XOM')
    uFactlet.addDataPoint(dates[i])
    uFactlet.addDataPoint(xom_price[i])
    uFactlet.addDataPoint(fds_volume[i])
    
df = fsod.executeFactlet(uFactlet)
df.throwErrorIfAnyIsPresent()

# In this example, we will run ExtractFormulaHistory and examine the unique
# IDs and Dates in the returned data
df = fsod.ExtractFormulaHistory("xom,stl-no,fds,ibm,efc,appl,goog", "fg_eps(0,-1m,d)", "");
printOutFactletResults(df);

# Extract Benchmark Detail
df = fsod.ExtractBenchmarkDetail("SP50","FG_COMPANY_NAME,FG_MKT_VALUE","");
printOutFactletResults(df);

df = fsod.ExtractBenchmarkDetail("SP50","p_price,proper_name","", Array[str]([ "cutoff", "10" ]));
printOutFactletResults(df);

df = fsod.ExtractBenchmarkDetail("SP50","p_price","20110115:20110120:d");
printOutFactletResults(df);


print('Press enter to continue')
raw_input()